	REM
	REM       Hotel Bunny
	REM
	REM   I re-visited this very simple, one-button game, and added a 
	REM   limited invulnerability "carrot power" feature, as well as 
	REM   multiple levels, with different dog configurations.
	REM
	REM   I also added an intro screen, as well as inter-level transition screens.
	REM
	REM   The code quality is poorer than what I usually write. I think
	REM   it's because the BASIC language just doesn't inspire me enough
	REM   to keep the code as clean as I would in a preferred language.
	REM
	REM             by Sebastian Mihai, 2015, 2016
	REM             http://sebastianmihai.com
	REM

	WAIT
	DEFINE 0,5,bunny_frame_1
	
	SOUND_VOLUME = 12
	LEVEL_TITLE_DELAY = 60
	
	HIDELEVELNAMEFRAMECOUNT = 75
	
init:
	COLLISIONX = 0
	COLLISIONY = 0
	
	NUMINITIALBUNNIES = 9
	BUNNIESNEEDED = 5
	
	NUMLEVELS = 10
	LEVEL = 0
	CARROTSTEP = 8
	
	DOGBOTTOM = 95
	DOGTOP = 8
	
	LEVELNAMEVISIBLE = 1
	FRAMECOUNTER = 0
	
	CLS
	PRINT AT 4 COLOR 6, "HOTEL  BUNNY"
	PRINT AT 40 COLOR 5, "Press"
	PRINT AT 82 COLOR 5, "RIGHT to launch"
	PRINT AT 122 COLOR 5, "BUTTON to use"
	PRINT AT 142 COLOR 5,"carrot power"
	
	PRINT AT 201 COLOR 2, "by SEBASTIAN MIHAI"
	PRINT AT 221 COLOR 2, "sebastianmihai.com"
	
	SPRITE 0, 23+$600, 8+$100,$0807
	SPRITE 1, 137+$600, 8+$500,$0807
	
init_wait:
	WAIT
	REM wait for any button to start the game
	IF CONT1.BUTTON THEN ELSE GOTO init_wait

	GOSUB play_start_sound
	
	CLS
	PRINT AT 4 COLOR 6, "HOTEL  BUNNY"
	PRINT AT 105 COLOR 5, "Good luck!"
	
	PRINT AT 201 COLOR 2, "by SEBASTIAN MIHAI"
	PRINT AT 221 COLOR 2, "sebastianmihai.com"

	GOTO next_level
	GOTO init

level_one:
	DOG1ENABLED = 0
	DOG2ENABLED = 0
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG3X = 120
	DOG3Y = 30
	DOG3YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_one_intro
	GOTO nextrabbit
	
level_two:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 0
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 55
	DOG1Y = DOGBOTTOM - 20
	DOG1YDELTA = -1
	DOG2X = 105
	DOG2Y = DOGTOP + 20
	DOG2YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_two_intro
	GOTO nextrabbit

level_three:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 65
	DOG1Y = 50
	DOG1YDELTA = 1
	DOG2X = 85
	DOG2Y = 60
	DOG2YDELTA = 1
	DOG3X = 105
	DOG3Y = 70
	DOG3YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_three_intro
	GOTO nextrabbit

level_four:
	DOG1ENABLED = 1
	DOG2ENABLED = 0
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 55
	DOG1Y = 50
	DOG1YDELTA = 1
	DOG3X = 115
	DOG3Y = 70
	DOG3YDELTA = 2
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_four_intro
	GOTO nextrabbit

level_five:
	DOG1ENABLED = 0
	DOG2ENABLED = 1
	DOG3ENABLED = 0
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG2X = 105
	DOG2Y = 50
	DOG2YDELTA = 3
	
	HOTELX = 148
	HOTELY = 70
	
	GOSUB level_five_intro
	GOTO nextrabbit

level_six:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 35
	DOG1Y = 50
	DOG1YDELTA = 1
	DOG2X = 85
	DOG2Y = 70
	DOG2YDELTA = 1
	DOG3X = 135
	DOG3Y = 50
	DOG3YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_six_intro
	GOTO nextrabbit
		
level_seven:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 35
	DOG1Y = 50
	DOG1YDELTA = 2
	DOG2X = 85
	DOG2Y = 70
	DOG2YDELTA = 2
	DOG3X = 135
	DOG3Y = 50
	DOG3YDELTA = 2
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_seven_intro
	GOTO nextrabbit

level_eight:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 55
	DOG1Y = 50
	DOG1YDELTA = 1
	DOG2X = 85
	DOG2Y = 70
	DOG2YDELTA = -1
	DOG3X = 115
	DOG3Y = 50
	DOG3YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_eight_intro
	GOTO nextrabbit

level_nine:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 110
	DOG1Y = 30
	DOG1YDELTA = 1
	DOG2X = 120
	DOG2Y = 50
	DOG2YDELTA = 1
	DOG3X = 130
	DOG3Y = 70
	DOG3YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_nine_intro
	GOTO nextrabbit
	
level_ten:
	DOG1ENABLED = 1
	DOG2ENABLED = 1
	DOG3ENABLED = 1
	
	SCORE = 0
	BUNNIES = NUMINITIALBUNNIES
	CARROT = CARROTSTEP * 7
	
	DOG1X = 50
	DOG1Y = 30
	DOG1YDELTA = 2
	DOG2X = 70
	DOG2Y = 50
	DOG2YDELTA = 2
	DOG3X = 130
	DOG3Y = 70
	DOG3YDELTA = 1
	
	HOTELX = 148
	HOTELY = 50
	
	GOSUB level_ten_intro
	GOTO nextrabbit	
	
	
nextrabbit:
	FOR X = 1 TO 20
	WAIT
	NEXT X
	
	BUNNYX = 10
	BUNNYY = HOTELY + 2
	BUNNYXDELTA = 0
	NEXT_BUNNY = 0

	GOSUB displaycarrotpower
	GOTO main

	
main:
	INVINCIBLE = 0

	GOSUB checkinput
	
	IF INVINCIBLE=1 THEN GOTO main_after_dog_collision
	
	IF DOG1ENABLED = 0 THEN GOTO main_check_dog2_collision
	COLLISIONX = DOG1X
	COLLISIONY = DOG1Y
	GOSUB checkcollision
main_check_dog2_collision:
	IF DOG2ENABLED = 0 THEN GOTO main_check_dog3_collision
	COLLISIONX = DOG2X
	COLLISIONY = DOG2Y
	GOSUB checkcollision
main_check_dog3_collision:
	IF DOG3ENABLED = 0 THEN GOTO main_after_dog_collision
	COLLISIONX = DOG3X
	COLLISIONY = DOG3Y
	GOSUB checkcollision

main_after_dog_collision:
	REM We perform this check up here to not get a further "step" after
	REM the collision
	IF BUNNIES = 0 THEN IF SCORE >= BUNNIESNEEDED THEN GOTO next_level
	
	IF NEXT_BUNNY = 1 THEN GOTO nextrabbit
	
	WAIT
	FRAMECOUNTER = FRAMECOUNTER + 1
	
	REM Hide level name after a while
	IF LEVELNAMEVISIBLE = 0 THEN GOTO main_after_hiding_level_name
	IF FRAMECOUNTER <> HIDELEVELNAMEFRAMECOUNT THEN GOTO main_after_hiding_level_name
	LEVELNAMEVISIBLE = 0
	GOSUB erase_level_name
	
main_after_hiding_level_name:
	REM RABBIT
	BUNNYX = BUNNYX + BUNNYXDELTA
	IF FRAMECOUNTER%20<10 THEN SPRITE 0,BUNNYX+$600,BUNNYY+$100,$080F ELSE SPRITE 0,BUNNYX+$600,BUNNYY+$100,$0807
	IF BUNNYXDELTA = 0 THEN SPRITE 0,BUNNYX+$600,BUNNYY+$100,$0807
	
	REM DOGS
	
	IF DOG1ENABLED = 0 THEN GOTO main_display_dog2
	IF DOG1Y > DOGBOTTOM THEN DOG1YDELTA = -1 * DOG1YDELTA
	IF DOG1Y < DOGTOP THEN DOG1YDELTA = -1 * DOG1YDELTA
	DOG1Y = DOG1Y + DOG1YDELTA
	IF FRAMECOUNTER%24<12 THEN SPRITE 1, DOG1X+$600, DOG1Y+$100, $0814 ELSE SPRITE 1, DOG1X+$600, DOG1Y+$100, $081C
	
main_display_dog2:
	IF DOG2ENABLED = 0 THEN GOTO main_display_dog3
	IF DOG2Y > DOGBOTTOM THEN DOG2YDELTA = -1 * DOG2YDELTA
	IF DOG2Y < DOGTOP THEN DOG2YDELTA = -1 * DOG2YDELTA
	DOG2Y = DOG2Y + DOG2YDELTA
	IF FRAMECOUNTER%16<8 THEN SPRITE 2, DOG2X+$600, DOG2Y+$100, $0816 ELSE SPRITE 2, DOG2X+$600, DOG2Y+$100, $081E

main_display_dog3:
	IF DOG3ENABLED = 0 THEN GOTO main_after_dog_display
	IF DOG3Y > DOGBOTTOM THEN DOG3YDELTA = -1 * DOG3YDELTA
	IF DOG3Y < DOGTOP THEN DOG3YDELTA = -1 * DOG3YDELTA
	DOG3Y = DOG3Y + DOG3YDELTA
	IF FRAMECOUNTER%14<7 THEN SPRITE 3, DOG3X+$600, DOG3Y+$100, $0815 ELSE SPRITE 3, DOG3X+$600, DOG3Y+$100, $081D

main_after_dog_display:
	REM HOTEL
	SPRITE 4, HOTELX+$600, HOTELY+$100, $0823
	
	GOSUB checksafe
	GOSUB displaycarrotpower
	
	PRINT AT 220 COLOR 1, "Saved:", (SCORE+16)*8+6
	PRINT AT 231 COLOR 1, "Bunnies:", (BUNNIES+16)*8+6
	IF SCORE >= BUNNIESNEEDED THEN IF FRAMECOUNTER%20 < 10 THEN PRINT AT 227 COLOR 5, "OK!"
	IF SCORE >= BUNNIESNEEDED THEN IF FRAMECOUNTER%20 >= 10 THEN PRINT AT 227 COLOR 2, "OK!"
	
	IF BUNNIES = 0 THEN IF SCORE < BUNNIESNEEDED THEN GOTO gameover ELSE GOTO next_level
	IF NEXT_BUNNY = 1 THEN GOTO nextrabbit
	
	GOTO main

REM Check collision between bunny and coordinates in COLLISIONX and COLLISIONY
checkcollision:	PROCEDURE
	IF BUNNYX > COLLISIONX THEN T = BUNNYX - COLLISIONX ELSE T = COLLISIONX - BUNNYX
	IF T > 14 THEN GOTO checkcollisionend
	IF BUNNYY > COLLISIONY THEN T = BUNNYY - COLLISIONY ELSE T = COLLISIONY - BUNNYY
	IF T > 7 THEN GOTO checkcollisionend
	BUNNIES = BUNNIES - 1
	NEXT_BUNNY = 1
	GOSUB play_lost_life_sound
checkcollisionend: END

REM Check whether bunny reached the hotel
checksafe:	PROCEDURE
	IF BUNNYX < HOTELX THEN GOTO checksafeend
	BUNNYXDELTA = 0
	BUNNIES = BUNNIES - 1
	SCORE = SCORE + 1
	NEXT_BUNNY = 1
	GOSUB play_safe_sound
checksafeend:	END

checkinput:	PROCEDURE
	REM Begin moving the bunny if the player pressed the right button
	IF CONT1.RIGHT THEN BUNNYXDELTA = 2
	
	REM Activate carrot power if any of the three buttons was pressed
	IF CONT1.B0 THEN GOSUB usecarrotpower ELSE IF CONT1.B1 THEN GOSUB usecarrotpower ELSE IF CONT1.B2 THEN GOSUB usecarrotpower
checkinputend:	END

usecarrotpower:	PROCEDURE
	IF CARROT=0 THEN GOTO usecarrotpowerend
	
	CARROT=CARROT-1
	INVINCIBLE=1
	
	REM MAKE BUNNY CARROT-RED!
	SPRITE 0,BUNNYX+$600,BUNNYY+$100,$0802
usecarrotpowerend:	END

displaycarrotpower:	PROCEDURE
	PRINT AT 0 COLOR 1, "Carrot Power:"
	PRINT AT 13 COLOR 2, ""
	
	IF CARROT=0 THEN GOTO displaycarrotpower_done
	
	FOR X = 1 TO CARROT STEP CARROTSTEP
	PRINT COLOR 2, ">"
	NEXT X
displaycarrotpower_done:	
	REM Cover "left-over" carrot power lines
	PRINT "       "
displaycarrotpowerend:	END


level_one_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 1"
	PRINT AT 124 COLOR 3, "QUIET STREET"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_one_introend:	END


level_two_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 2"
	PRINT AT 124 COLOR 3, "MIDTOWN PARK"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_two_introend:	END


level_three_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 3"
	PRINT AT 124 COLOR 3, "CROWDED MALL"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_three_introend:	END


level_four_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 4"
	PRINT AT 122 COLOR 3, "DOWNTOWN STREET"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_four_introend:	END


level_five_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 5"
	PRINT AT 126 COLOR 3, "BAY AREA"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_five_introend:	END


level_six_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 6"
	PRINT AT 124 COLOR 3, "SUPERMARKET"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_six_introend:	END


level_seven_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 7"
	PRINT AT 125 COLOR 3, "RUSH HOUR"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_seven_introend:	END


level_eight_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 8"
	PRINT AT 123 COLOR 3, "POSH PROMENADE"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_eight_introend:	END


level_nine_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 9"
	PRINT AT 122 COLOR 3, "HIGHWAY EXIT RAMP"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_nine_introend:	END


level_ten_intro:	PROCEDURE
	CLS
	PRINT AT 86 COLOR 3, "LEVEL 10"
	PRINT AT 128 COLOR 3, "HOME"
	FOR X = 1 TO LEVEL_TITLE_DELAY
	WAIT
	NEXT X
level_ten_introend:	END

erase_level_name:	PROCEDURE
	PRINT AT 60 COLOR 3, "                    "
	PRINT AT 80 COLOR 3, "                    "
	PRINT AT 100 COLOR 3, "                    "
	PRINT AT 120 COLOR 3, "                    "
	PRINT AT 140 COLOR 3, "                    "
erase_level_nameend:	END

hide_sprites:		PROCEDURE
	SPRITE 0,0+$600,0+$100,$0800
	SPRITE 1,0+$600,0+$100,$0800
	SPRITE 2,0+$600,0+$100,$0800
	SPRITE 3,0+$600,0+$100,$0800
	SPRITE 4,0+$600,0+$100,$0800
hide_sprites_end:	END

gameover:
	GOSUB hide_sprites
	
	PRINT AT 231 COLOR 5, "GAME OVER"
	
	FOR X = 1 TO 240
	WAIT
	NEXT X
	CLS
	GOTO init
	
next_level:
	FRAMECOUNTER = 0
	LEVELNAMEVISIBLE = 1

	FOR X = 1 TO 120
	WAIT
	NEXT X
	CLS
	GOSUB hide_sprites
	LEVEL = LEVEL + 1

	IF LEVEL = 1 THEN GOTO level_one
	IF LEVEL = 2 THEN GOTO level_two
	IF LEVEL = 3 THEN GOTO level_three
	IF LEVEL = 4 THEN GOTO level_four
	IF LEVEL = 5 THEN GOTO level_five
	IF LEVEL = 6 THEN GOTO level_six
	IF LEVEL = 7 THEN GOTO level_seven
	IF LEVEL = 8 THEN GOTO level_eight
	IF LEVEL = 9 THEN GOTO level_nine
	IF LEVEL = 10 THEN GOTO level_ten
victory:	
	PRINT AT 102 COLOR 5, "CONGRATULATIONS!"
	
	FOR X = 1 TO 240
	WAIT
	NEXT X
	CLS
	
	GOTO init
	
	
play_start_sound:	PROCEDURE
	SOUND 2, 250, SOUND_VOLUME
	FOR X = 1 TO 60
	WAIT
	IF X = 10 THEN SOUND 2, 240, SOUND_VOLUME
	IF X = 20 THEN SOUND 2, 230, SOUND_VOLUME
	IF X = 30 THEN SOUND 2, 220, SOUND_VOLUME
	IF X = 40 THEN SOUND 2, 230, SOUND_VOLUME
	IF X = 50 THEN SOUND 2, 220, SOUND_VOLUME
	NEXT X
	GOSUB turn_off_sound
play_start_soundend: END
	
play_lost_life_sound:	PROCEDURE
	FOR X = 1 TO 20
	WAIT
	SOUND 2, 210+X*2, SOUND_VOLUME
	NEXT X
	GOSUB turn_off_sound
play_lost_life_soundend: END

play_safe_sound:	PROCEDURE
	FOR X = 1 TO 20
	WAIT
	SOUND 2, 220-X*2, SOUND_VOLUME
	NEXT X
	GOSUB turn_off_sound
play_safe_soundend: END
	
turn_off_sound:		PROCEDURE
	SOUND 2, 1, 0
turn_off_soundend:	END

REM 	
REM 
REM Graphics
REM 
REM 
bunny_frame_1:
	BITMAP "00101000"
	BITMAP "00010100"
	BITMAP "00001110"
	BITMAP "00111110"
	BITMAP "01111100"
	BITMAP "01111100"
	BITMAP "00111100"
	BITMAP "00011000"

bunny_frame_2:
	BITMAP "00101000"
	BITMAP "00010100"
	BITMAP "00001110"
	BITMAP "00111110"
	BITMAP "01111100"
	BITMAP "01111100"
	BITMAP "00111100"
	BITMAP "00100100"
	
dog:
	BITMAP "00101000"
	BITMAP "00110000"
	BITMAP "11110000"
	BITMAP "11111001"
	BITMAP "00111110"
	BITMAP "01111110"
	BITMAP "01100110"
	BITMAP "11001100"

dog_2:
	BITMAP "01010000"
	BITMAP "00110000"
	BITMAP "11110000"
	BITMAP "11111000"
	BITMAP "00111111"
	BITMAP "01111110"
	BITMAP "01100110"
	BITMAP "01100011"
	
hotel:
	BITMAP "00111100"
	BITMAP "01111110"
	BITMAP "11111111"
	BITMAP "11111111"
	BITMAP "11111111"
	BITMAP "11111111"
	BITMAP "11100111"
	BITMAP "11100111"
